/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig
          (C) 2005 Mark Haemmerling <avr.webserver@markh.de>

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@ulrichradig.de

oder im Forum meiner Web Page : www.ulrichradig.de

...oder an Mark (Adr. s. oben) :)

Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include "main.h"

//Die beiden hier knnte man vieleicht doch besser ins RAM legen. Holgi
//MAC Addresse des AVR
const unsigned char mymac[] = {30,10,43,43,45,77};

//MAC Addresse des SMTP-Servers
const unsigned char smtp_srv_mac[] = {0x00,0x50,0xda,0x08,0x18,0x27}; // MH: mein rechner "bender"

// IP Addresse des AVR
const unsigned char MYIP[] = {192,168,100,67};

// IP Adresse des SMTP-Servers:
const unsigned char MailIP[] = {192,168,100,65}; // MH: "bender"

//Array fr zu empfangene Daten und zu sendene Daten
unsigned char packet[MTU_SIZE];

PROGMEM char SYS_WELCOME[] = "\nLittleFeather.org\nEmbedded Ethernet Server\nVersion 0.1.0\n(C) Ulrich Radig,\n    Mark Hmmerling\n\n";
PROGMEM char SYS_NIC_INIT[] = "- Init. NE2000 NIC: ";
PROGMEM char SYS_SD_INIT[] = "- Init. SD/MMC memory card: ";
PROGMEM char SYS_OK[] = "OK\n";
PROGMEM char SYS_ERR[] = "ERROR!\n";
PROGMEM char SYS_READY[] = "\nThe server is now ready.\n";

//############################################################################
//Hauptprogramm
int main (void)
//############################################################################
{
	UART_Init();

	printf_P(SYS_WELCOME);
	#if USE_MMC	
		printf_P(SYS_SD_INIT);
		while (mmc_init() != 0) //ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
								//MMC/SD-Karte wird dann neu Initialisiert
			{
			printf_P(SYS_ERR);
			}
		printf_P(SYS_OK);
//		printf ("SD OK\n");
		//Speichern der Cluster Size und Cluster Offset (Anfang Datenbereich)
		Cluster_Data_Store(); // !> INS RAM!!
	#endif

	//Grundinizialisierung der Netzwerkkarte
	printf_P(SYS_NIC_INIT);
	Init_Realtek_Network_Card();

//	printf ("Init: %d\n",ReadRTL(0));
	if (ReadRTL(0) != 34) {
		printf_P(SYS_ERR);
		for(;;); // HALT SYSTEM!
	} else {
		printf_P(SYS_OK);
	}

	//Ausgabe meiner MAC Adresse auf Serieller Schnittstelle
//	printf ("\nMAC: %x.%x.%x.%x.%x.%x\n",mymac[0],mymac[1],mymac[2],mymac[3],mymac[4],mymac[5]);

	//Ausgabe meiner IP Adresse auf Serieller Schnittstelle
//	printf ("IP: %d.%d.%d.%d\n\n",MYIP[0],MYIP[1],MYIP[2],MYIP[3]);	

	for (unsigned char b = 0; b <= 100; b++) {
		printf("INITIAL WAIT: %3u%%\r", b);
	}
	printf("\n");

	// hardware init
	DDRD |= (1<<4);
	
	//Globale Interrupts Einschalten
	sei ();
	
	//Interrupt 4 Mega103/128 Interrupt 0 bei Mega32 
	//soll auslsen bei ansteigender Flanke
	Networkcard_INT_Set();
	
	//Interrupt 4 oder 0 Einschalten (fr die Netzwerkkarte)
	Networkcard_INT_Enable();

	#if USE_CLOCK
		Start_Clock();
	#endif

	//Hauptprogramm luft stndig in einer schleife und macht nichts

	printf_P(SYS_READY);

/*
	printf("InitSendMail\n");
	sendmail(packet, 0);
*/

/*	MH:
	die idee mit dem mail_state sollte erstmal klappen. aber theoretisch kann es sein,
	da ein neuer versand und eine neue verbindung getriggert werden, obwohl die vorherige
	verbindung noch nicht ganz beendet ist (gegenstelle-tcp ist noch offen). dann darf
	eigentlich keine neue verbindung (zumindest vom gleichen port) kommen!
	lsung evtl: bei ausgehenden verbindungen portnummern aus einem kleinen pool nehmen (mu nicht
	grer sein als anzahl max. verbindungen) nehmen (erhhen, modulo anzahl verbindungen, +basisportnr.)
	dann gehts wirklich parallel.
*/
	char mail_state = 0;
	while (1) {
		if (mail_state == 0) { // momentan kein versand getriggert
			if (vars.type_int[MAILFLAGS_ADDR] != 0) {
				cli();
				printf("MailTrigger\n");
				sendmail(packet, 0);
				sei();
				mail_state = 1;
			}
		} else {
			// versand wurde getriggert
			if (vars.type_int[MAILFLAGS_ADDR] == 0) {
				mail_state = 0;
			}
		}

		if (vars.type_char[6] & (1<<0)) {
			PORTD |= (1<<4);
		} else {
			PORTD &= ~(1<<4);
		}
	}
	
	return (1);
}
