/*
Copyright (C) 2005 Mark Haemmerling <avr.webserver@markh.de>
*/

#include "main.h"
#include "sendmail.h"
#include "socket.h"

/*
TODO:
bitmaske auf u16 legen, global definieren.
mailversand wird gestartet (sendmail()) sobald diese var. != 0 ist
wenn dann smtp abluft, wird diese bitmaske abgearbeitet und fr jedes gesetzte
bit die entsprechende mail versand (sind dann halt 16 templates auf SD, die geladen und versandt
werden. auf wunsch kann in die datei auch ein "from:" und "to:" in den header,
mu halt nur der smpt-server mitmachen. exim machts :).
nach versand bit lschen und mit RSET getrennt evtl. auch noch andere mails verschicken (innerhalb
der verbindung).
dann bei bit0 angekommen, normal beenden wie gehabt.
diese variable kann dann ja ganz normal vom cgi-teil (bzw. vom i/o-gert) beschrieben werden.
ist einfach eine variable, deren adresse per define festgelegt wird.

anmerkung fuer den leser: :)
"i/o-geraet" ist das geraet, was extern an den webserver angebunden wird (und die eigentliche steuerung
uebernimmt. ich hatte mir das so gedacht,
dass der globale datenbereich (auf den per cgi zugegriffen werden kann) zwischen diesen beiden geraeten
synchronisiert wird. das i/o-geraet kann dann mit dem gleichen speicher arbeiten. dieser speicher wird
aufgeteilt in readonly und read/write bereich fuer jedes der beiden geraete...
soweit bin ich aber nicht gekommen, bevor ich den spass auf eis gelegt habe.
*/

PROGMEM char SMTP_HELO[] = "HELO lfeather\r\n"; // hier absender rein??
PROGMEM char SMTP_RSET[] = "RSET\r\n";
PROGMEM char SMTP_MAIL[] = "MAIL FROM: lfeather@markh.de\r\n";
PROGMEM char SMTP_RCPT[] = "RCPT TO: mark@localhost\r\n"; // hier user eintragen, an den die mail gehen soll
PROGMEM char SMTP_DATA[] = "DATA\r\n";
PROGMEM char SMTP_TEXT[] = "Subject: Mail file not found\r\n\r\nDear user,\r\n\r\nthere was a mail request which could not be satisfied due to a missing mail template file.\r\n\r\nRegards.";
PROGMEM char SMTP_END[]  = "\r\n-- \r\nSent by the LittleFeather.org embedded mailing subsystem\r\n.\r\n";
PROGMEM char SMTP_QUIT[] = "QUIT\r\n";

#define BLOCK_SIZE BlockSize // aus fat.h

void smtp(char* buffer, int *bufferlen) {
	unsigned int tcpdata;
	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	//Verwaltung Stackpointer
	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack(buffer,bufferlen,&a) == 1) return; //keine Daten fr Anwendung
	tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

	//berprft daten
	if (tcp_socket->Status == TCP_SOCKET_OPEN1) {
		unsigned char data = ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0); // wenn daten zu lesen sind
		unsigned int code;
		unsigned int i = 0;
		unsigned char complete = 0;
		
		if (data) {
			buffer[tcpdata+3] = '\0';
			code = atoi(buffer+tcpdata);
		} else {
			code = -1;
		}

		tcp_store(buffer);	
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG | PSH_FLAG;

		if ((!data) || (code < 500)) {
			unsigned char Dir_Attrib;
			unsigned char File_Name[13];
//			printf("Smtp(%u),Cs(%u)\n", code, tcp_socket->CommStage);
			switch (tcp_socket->CommStage) {
			case 0:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_HELO);
					tcp_socket->CommStage++;
				}
				break;
			case 1:
				if (data) {
					// !> bestimmen, welches template als nchstes geschickt werden soll!
					for (tcp_socket->Data0 = 0; tcp_socket->Data0 < 16; tcp_socket->Data0++) {
						if (vars.type_int[MAILFLAGS_ADDR] & (1<<tcp_socket->Data0)) break;
					}
					sprintf(File_Name, "mail-%02u.txt", tcp_socket->Data0);
					printf(File_Name);
					// lade pointer auf mail text
					tcp_socket->Cluster = 0; //suche im Root Directory
					if (Search_File(File_Name, &tcp_socket->Cluster, &tcp_socket->File_Size, &Dir_Attrib, &buffer[tcpdata]) == 1) {
						printf("->OK\n");
					} else {
						// wenn nicht gefunden, schicke standard-mail
						printf("->NotFound\n");
						tcp_socket->Cluster = 0;
					}
					tcp_socket->File_Block_Counter = 0;
					i = sprintf_P(buffer+tcpdata, SMTP_RSET);
					tcp_socket->CommStage++;
				}
				break;
			case 2:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_MAIL);
					tcp_socket->CommStage++;
				}
				break;
			case 3:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_RCPT);
					tcp_socket->CommStage++;
				}
				break;
			case 4:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_DATA);
					tcp_socket->CommStage++;
				}
				break;
			case 5:
				if (((!data) && (tcp_socket->File_Block_Counter > 0)) || // wenn keine response vom smtp, mache nur weiter, wenn dies eine fortsetzung von daten ist
				(data)) { // oder wenn eine response vom smtp server kam (nur am anfang, dann nicht mehr innerhalb der daten)
					if (tcp_socket->Cluster != 0) {
						// block aus datei laden
						if (tcp_socket->File_Size > (unsigned long) BLOCK_SIZE) {
							i = BLOCK_SIZE;
							(unsigned long) tcp_socket->File_Size = (unsigned long) tcp_socket->File_Size - BLOCK_SIZE;
						} else {
							i = tcp_socket->File_Size;
							complete = 1;
						}
						Read_File(tcp_socket->Cluster, buffer+tcpdata, tcp_socket->File_Block_Counter);
						tcp_socket->File_Block_Counter++;
					} else {
						// datei nicht gefunden, sende standard-mail
						i = sprintf_P(buffer+tcpdata, SMTP_TEXT);
						// muss in tcp buffer passen!!!
						complete = 1;
					}
					if (complete) {
						vars.type_int[MAILFLAGS_ADDR] &= ~(1<<tcp_socket->Data0);
						if (vars.type_int[MAILFLAGS_ADDR]) {
							tcp_socket->CommStage = 1; // mache weiter mit RSET
						} else {
							tcp_socket->CommStage++; // beende verbindung
						}
						// hnge ende-code an (alleinstehender ".")
						i += sprintf_P(buffer+tcpdata+i, SMTP_END);
					}
				}
				break;
			default:
				if (data) {
					i = sprintf_P(buffer+tcpdata, SMTP_QUIT);
					tcp_socket->CommStage++;
				}
				break;
			}
		} else {
			// fehler. quit senden, commstage setzen, da es nicht mehr oben greift
			printf("SmtpErr(%u)\n", code);
			i = sprintf_P(buffer+tcpdata, SMTP_QUIT);
			tcp_socket->CommStage = -1;
		}

		TCP_New_Packtlen(buffer, bufferlen, tcpdata + i);
		tcp_make(buffer);			
		Write_Ethernet_Frame (buffer,*bufferlen);	
	}
}

void sendmail(char *buffer, int bufferlen) {
	//Pointer auf Ethernet_Header
	struct Ethernet_Header *ethernet;
	ethernet = (struct Ethernet_Header *)&buffer[ETHER_OFFSET];
	//Pointer auf IP_Header
	struct IP_Header *ip;
	ip = (struct IP_Header *)&buffer[IP_OFFSET];
	//Pointer auf TCP_Header
	struct TCP_Header *tcp;
	tcp = (struct TCP_Header *)&buffer[TCP_OFFSET];

	unsigned int tcpdata;

	ethernet->EnetPacketType = 0x0008; // IP
	ip->IP_Proto = PROT_TCP; // TCP

	ip->IP_Srcaddr = *((unsigned long *)&MailIP[0]);
	for (unsigned char a = 0; a < 6; a++) {
		ethernet->EnetPacketSrc[a] = smtp_srv_mac[a];
	}

	// FLAG FR UNFRAGMENTIERT SETZEN!
	// !> eigene routine: create_new_ip_header() oder so:
	ip->IP_Vers_Len = 0x45; // version 4, 5x 32bit header lnge
	ip->IP_Tos = 0x00;	// normales paket, keine spez. optionen
	ip->IP_Id = 0x00c0;	// einmalige ID. woher sollen wir die nehmen???
	ip->IP_Frag_Offset = 0x0040;	// don't fragment
	ip->IP_ttl = 64;	// max. hops
	ip->IP_Proto = PROT_TCP;	//Zeigt das hherschichtige Protokoll an 
	// --------- IP header sollte jetzt okay sein

	// !> eigene routine: create_new_tcp_header
	// neue verbindung. also seq und ack auf 0!
	buffer[TCP_ACKNUM+0] = 0;
	buffer[TCP_ACKNUM+1] = 0;
	buffer[TCP_ACKNUM+2] = 0;
	buffer[TCP_ACKNUM+3] = 0;

	buffer[TCP_SEQNUM+0] = 0;
	buffer[TCP_SEQNUM+1] = 0;
	buffer[TCP_SEQNUM+2] = 0;
	buffer[TCP_SEQNUM+3] = 0;

	buffer[TCP_HDRFLAGS+1] = FIN_FLAG; // nur damit tcp_store alles auf 0 lt!

	//Speichert Sequenzcounter und Aknowledgecounter
	tcp_store(buffer);

	//Setzen der flags
	buffer[TCP_HDRFLAGS+0] = ((20/4) << 4);; // 4bit lnge des tcp-headers in 32bit schritten, rechts davon flags
	buffer[TCP_HDRFLAGS+1] = SYN_FLAG;

	// low/high-byte entsprechend vertauscht, s. portnummern in socket.h
	buffer[TCP_SRCPORT+0]  = (SOCKET_SMTP & 0xff);
	buffer[TCP_SRCPORT+1]  = (SOCKET_SMTP >> 8);
	buffer[TCP_DESTPORT+0] = (SOCKET_SENDMAIL & 0xff);
	buffer[TCP_DESTPORT+1] = (SOCKET_SENDMAIL >> 8);

	buffer[TCP_WINDOW+0] = (MTU_SIZE >> 8); // MTU-size ist bestimmt nicht das gleiche wie window. aber besser als 5000 bytes!
	buffer[TCP_WINDOW+1] = (MTU_SIZE & 0xff);

	buffer[TCP_URGENTPTR+0] = 0;
	buffer[TCP_URGENTPTR+1] = 0;

	// !! hier mu ein gltiger ip header im buffer liegen, damit die berechnung hinhaut!
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
	TCP_New_Packtlen(buffer, &bufferlen, tcpdata);
	
	//Erzeugt ein TCP buffer
	tcp_make(buffer);
	
	// !> hier globales flag setzen, da demnchst eine TCP-verbindung remote 25 -> local 64
	//    erwartet wird. damit diese verb. akzeptiert wird, MUSS dieses flag gesetzt sein!
	//    nach eingegangener verb. flag wieder lschen!!
	
	//Sendet das erzeugte TCP buffer
	Write_Ethernet_Frame (buffer, bufferlen);
	printf("MailSyn\n");
}
