/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig
          (C) 2005 Mark Haemmerling <avr.webserver@markh.de>

#######################################################################################*/

#include "main.h"
#include "tcp.h" 
#include "mmc.h"

//Globale Variablen
unsigned long Seq_counter;
unsigned long Ack_counter;

struct TCP_Socket tcpsockets[Max_TCP_Sockets]; //Feld mit Max_TCP_Sockets Sockets
struct TCP_Socket *tcp_socket;                 //Pointer auf einen TCP_Socket

PGM_P pointerold;

//unsigned int sitecounter=0;

//############################################################################
//holt seqnum und acknum aus tcp-header und speichert sie in glob. variablen "..._counter"
// danach wird Seq_counter noch verndert. blick ich grad nich ganz durch
//############################################################################
void tcp_store (char *buffer) {
	//Variablen Fr die Routine
	unsigned int result16;
	
	//Pointer auf TCP_Header
	struct TCP_Header *tcp;
	tcp = (struct TCP_Header *)&buffer[TCP_OFFSET];
	
	//Store seq number to Seq_counter
	Seq_counter = (tcp->TCP_Seqnum[0] << 8)+tcp->TCP_Seqnum[1];
	Seq_counter = Seq_counter << 16;
	Seq_counter = Seq_counter +(unsigned int) ((tcp->TCP_Seqnum[2] << 8)
								+tcp->TCP_Seqnum[3]);

	//Store ack number to ACK_counter
	Ack_counter = (tcp->TCP_Acknum[0] << 8)+tcp->TCP_Acknum[1];
	Ack_counter = Ack_counter << 16;
	Ack_counter = Ack_counter +(unsigned int) ((tcp->TCP_Acknum[2] << 8)
								+tcp->TCP_Acknum[3]);

	//Calculate next seq number
	if ((tcp->TCP_HdrFlags[1] & FIN_FLAG) == 0) {
		result16 = (buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1]; // result16 = ip-paketlnge
		result16 = result16 - ((buffer[IP_VERS_LEN] & 0x0F) << 2) - ((buffer[TCP_HDRFLAGS] & 0xF0) >>2); // dort stehen wohl auch noch lngen drin (siehe tcp.h)

		if ((buffer[TCP_HDRFLAGS+1]&SYN_FLAG) > 0 && result16 == 0) result16 = 1;
		Seq_counter += result16;
	}
	return;
}

//############################################################################
//Fgt Daten aus dem Flash ROM hinzu
//############################################################################
char tcp_add_data (PGM_P pointer,char *buffer,int *bufferlen) {
	//Variablen Fr die Routine
	unsigned int result16;
	unsigned char Data = 1;
	unsigned char Buffer_Full = 0;

	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	for(;;) {
		Data = pgm_read_byte_near(pointer++);
		buffer[result16] = Data;
		result16++;
		
		//sind die daten lnger als ein Ethernetbuffer dann abbruch
		if (result16 >  (MTU_SIZE - 1)) {
			Buffer_Full = 1;
			//Speichern des Pointers
			pointerold = pointer;
			//Abbruch der Schleife
			break;
		}
				
		//Abbruch wenn %END erreicht wurde
		if (strncmp_P("%END", pointer, 3) == 0) break;
	}
	TCP_New_Packtlen(buffer, bufferlen, result16);
	return (Buffer_Full);
}

//############################################################################
//Fgt Daten aus dem RAM hinzu
//############################################################################
char tcp_add_datastring (char *pointer,char *buffer,int *bufferlen) {
	//Variablen Fr die Routine
	unsigned int result16;
	unsigned char Data = 1;
	unsigned char Buffer_Full = 0;

	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
				((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;

	for(;;)	{
		Data = *pointer++;
		buffer[result16] = Data;
		result16++;
		//sind die daten lnger als ein Ethernetbuffer dann abbruch
		if (result16 >  (MTU_SIZE - 1)) {
			Buffer_Full = 1;
			break;
		}
		//Abbruch wenn 0 erreicht wurde
		if (*pointer == 0) break;
	}
	TCP_New_Packtlen(buffer, bufferlen, result16);
	return (Buffer_Full);
}

//############################################################################
//
//############################################################################
void TCP_New_Packtlen (char *buffer,int *bufferlen,unsigned int result16) {
	//addiert noch bufferheader zur neuen ethernetlnge
	result16 = result16 + 4;
	*bufferlen = result16;
	//Errechnet die neue ip bufferlnge aus Ethernet Lnge 
	//Ethernetframe - bufferheader
	result16 = result16 - 18;
	//schreibt neue IPlnge ins buffer (ip_pktlenH)
	buffer[IP_PKTLEN] = ((result16 & 0xFF00) >> 8);
	//schreibt neue IPlnge ins buffer (ip_pktlenL)
	buffer[IP_PKTLEN+1] = (result16 & 0x00FF);
	return;
}

//############################################################################
//
//############################################################################
void tcp_make (char *buffer) {
	//Variablen Fr die Routine
	unsigned int result16;
	unsigned long result32 = 0x00000000;
	unsigned char DataH; // MH: !> eine davon einsparen und umbenennen!!
	unsigned char DataL;

	//Schreibt neuen seq und Ack Counter	
	buffer[TCP_ACKNUM]   = (Seq_counter & 0xFF000000) >> 24;
	buffer[TCP_ACKNUM+1] = (Seq_counter & 0x00FF0000) >> 16;
	buffer[TCP_ACKNUM+2] = (Seq_counter & 0x0000FF00) >> 8;
	buffer[TCP_ACKNUM+3] =  Seq_counter & 0x000000FF;
	
	buffer[TCP_SEQNUM]   = (Ack_counter & 0xFF000000) >> 24;
	buffer[TCP_SEQNUM+1] = (Ack_counter & 0x00FF0000) >> 16;
	buffer[TCP_SEQNUM+2] = (Ack_counter & 0x0000FF00) >> 8;
	buffer[TCP_SEQNUM+3] =  Ack_counter & 0x000000FF;
	
	//Tauscht den TCP source Port mit TCP destinations port yyyy >> XXXX
	
	DataH = buffer[TCP_SRCPORT];
	buffer[TCP_SRCPORT] = buffer[TCP_DESTPORT];
	buffer[TCP_DESTPORT] = DataH;
	
	DataL = buffer[TCP_SRCPORT+1];
	buffer[TCP_SRCPORT+1] = buffer[TCP_DESTPORT+1];
	buffer[TCP_DESTPORT+1] = DataL;
	
	//Erzeugt den IP Header	
	Make_IP_Header(buffer);

	//Berechnung der TCP Checksumme
	//Alle Daten im TCP Header werden addiert checksum wird deshalb
	//ersteinmal auf null gesetzt
	buffer[TCP_CHKSUM] = 0x00;
	buffer[TCP_CHKSUM+1] = 0x00;

	//Berechnet Headerlnge und Addiert Pseudoheaderlnge 2XIP = 8
	result16 = (buffer[IP_PKTLEN]<<8) + buffer[IP_PKTLEN+1] + 8;
	result16 = result16 - ((buffer[IP_VERS_LEN] & 0x0F) << 2);
	result32 = result16 - 2;

	//Pointer wird auf das erste buffer im IP Header gesetzt
	//Routine berechnet die Checksumme
	result16 = checksum (&buffer[IP_SRCADDR], result16, result32);

	//schreibt checksum ins buffer (INT H Byte)
	buffer[TCP_CHKSUM] = ((result16 & 0xFF00) >> 8);

	//schreibt checksum ins buffer (INT L Byte)
	buffer[TCP_CHKSUM+1] = (result16 & 0x00FF);

	//Habe Fertig!!
}

//############################################################################
//
//############################################################################
void TCP_PORT_CLOSE (char *buffer,int *bufferlen) {
	//Speichert Sequenzcounter und Aknowledgecounter
	tcp_store(buffer);
	//Setzen des FIN Flag
	buffer[TCP_HDRFLAGS+1] = ACK_FLAG | FIN_FLAG | PSH_FLAG;

	//Erzeugt ein TCP buffer
	tcp_make(buffer);
	//Sendet das erzeugte TCP buffer
	Write_Ethernet_Frame (buffer,*bufferlen);
}

//############################################################################
//MH: schaut nach, ob da jemand versucht, eine tcp-verbindung zu uns herzustellen (?)
//############################################################################
int TCP_OPEN (char *buffer,int *bufferlen) {
	unsigned int tcp_srcport;
	unsigned int tcp_destport;
	
	tcp_srcport = (buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];
	tcp_destport = (buffer[TCP_DESTPORT]<<8) + buffer[TCP_DESTPORT+1];
	
	unsigned char tcp_hdrflags1 = buffer[TCP_HDRFLAGS+1];
 
	if ((tcp_hdrflags1 & SYN_FLAG) > 0 && (tcp_hdrflags1 & (PSH_FLAG | ACK_FLAG)) == 0) {
		// ist das allererste was bei verbindungsaufbau kommt: SYN
		unsigned char a;
		printf("SYN(%u>%u)", tcp_srcport, tcp_destport);
		//Speichern des Socket
		for (a=0; a<Max_TCP_Sockets; a++) {
			tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

			if (tcp_socket->Store == 0) { // socket ist frei. diesen benutzen.
				tcp_socket->Store = tcp_srcport;
				tcp_socket->CommStage = 0;
				tcp_socket->Status = TCP_SOCKET_NOT_USED;
				break;
			}
		}
		
		printf(" @ %u\n", a);
		
		// MH: was ist denn wenn gar kein socket mehr frei ist??
		// dann knnen wir doch nicht einfach ein ACK schicken!
		// hier (also wenn a == Max_TCP_Sockets) mu ein Connection Refused
		// verursacht werden!! genau wie wenn auf einen geschlossenen port zugegriffen wird!
		// also sollte die ganze antwort-geschichte vielleicht bis dahin verzgert werden?
		
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);		
		//Setzen des Ack Flag
		buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
		//Erzeugt ein TCP buffer 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP buffer 
		Write_Ethernet_Frame(buffer, *bufferlen);
		return(1);
	}

	// MH: fr eine verbindung, die wir aufgebaut haben, und die nun geffnet werden kann.
	//  sollte das selbe sein wie oben, nur hier im if() eine andere bedingung.
	//  !> mergen!
	if ((tcp_hdrflags1 & SYN_FLAG) > 0 && (tcp_hdrflags1 & ACK_FLAG) > 0) {
		unsigned char a;
		printf("SYN,ACK(%u>%u)", tcp_srcport, tcp_destport);
		//Speichern des Socket
		for (a=0; a<Max_TCP_Sockets; a++) {
			tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

			if (tcp_socket->Store == 0) { // socket ist frei. diesen benutzen.
				tcp_socket->Store = tcp_srcport;
				tcp_socket->CommStage = 0;
				tcp_socket->Status = TCP_SOCKET_OPEN1; // NOT_USED machen und unten nach dem ack auf open setzen??
				break;
			}
		}

		printf(" @ %u\n", a);
		
		// MH: was ist denn wenn gar kein socket mehr frei ist??
		// dann knnen wir doch nicht einfach ein ACK schicken!
		// hier (also wenn a == Max_TCP_Sockets) mu ein Connection Refused
		// verursacht werden!! genau wie wenn auf einen geschlossenen port zugegriffen wird!
		// also sollte die ganze antwort-geschichte vielleicht bis dahin verzgert werden?
		
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);		
		//Setzen des Ack Flag
		buffer[TCP_HDRFLAGS+1] &= ~(SYN_FLAG);
		buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
		//Erzeugt ein TCP buffer 
		tcp_make(buffer);
		//Sendet das erzeugte TCP buffer 
		Write_Ethernet_Frame(buffer, *bufferlen);
		return(1);
	}
	
	// MH: RST kommt wohl vom partner wenn er eine verbindung beendet.
	//     stack-eintrag wird hier jedenfalls wieder freigemacht.
	//     wir senden darauf kein ACK mehr.
	if ((tcp_hdrflags1 & RST_FLAG) > 0) {
		unsigned char a;
		printf("RST(%u>%u)", tcp_srcport, tcp_destport);
		for (a=0; a<Max_TCP_Sockets; a++) {
			tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
			if (tcp_socket->Store == tcp_srcport) {
				tcp_socket->Store = 0;
				break;
			}
		}
		printf(" X %u\n", a);
		
		return(1);
	}
	
	// MH: partner will sich wohl von uns trennen (*schnief*)
	//     wir erhalten ein FIN flag und sagen daraufhin, da die trennung anerkannt wurde
	//     (wir senden das RST als acknowledge)
	if ((tcp_hdrflags1 & FIN_FLAG) > 0) {
		unsigned char a;
		printf("FIN(%u>%u)", tcp_srcport, tcp_destport);
		for (a=0; a<Max_TCP_Sockets; a++)	{
			tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
			if (tcp_socket->Store == tcp_srcport) {
				tcp_socket->Store = 0;
				break;
			}
		}
		
		printf(" X %u\n", a);
		
		//Setzen des Ack Flag
		buffer[TCP_HDRFLAGS+1] = RST_FLAG;
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);	
		//Seq_counter um 1 erhhen
		Seq_counter++;
		//Erzeugt ein TCP buffer 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP buffer 
		Write_Ethernet_Frame(buffer, *bufferlen);	
		return(1);
	}
	return(0);
}

//############################################################################
//Verwaltet TCP Stack
// wenn 0 zurckgeliefert wird, bedeutet das, die anwendung (ftpd/httpd...) kann schauen, ob es
//  sich um das ffnen oder schlieen eines ports handelt, oder ob sogar daten zur anwendung flieen
// wird 1 zurckgeliefert, braucht sich die anwendung (der daemon) nicht weiter drum zu kmmern.
//  dann war es eine interne geschichte, die innerhalb dieser routine hier schon behandelt wurde (ACK
//  senden o..)
//############################################################################
char TCP_Stack(char *buffer, int *bufferlen, unsigned char *Stackpointer) {
	//ist fr Verbindungsaufbau zustndig TCP SYNC
	//MH: TCP_OPEN gibt 1 zurck, wenn antwort an partner gesandt wurde (also alles okay ist)
	// danach steht ->Status dann auf ...NOT_USED
	// wenn verbindung wirklich aufgebaut wird, wird dann hier ack gesendet und ->Status auf OPEN1 gestellt

	// MH: TCP_OPEN knnte man hier eigentlich inline einsetzen. weil es eh nur hier
	// benutzt wird. wrde auch deutlich machen, da die ganze verbindungsverwaltung eigentlich
	// hier (in TCP_Stack) passiert (wovon TCP_OPEN echt nur eine unterroutine ist)
	if (TCP_OPEN(buffer,bufferlen)==1) // MH: sollte das hier (TCP_Stack) nicht global im interrupt gehandelt werden, statt durch jeden daemon einzeln??
		return(1);//keine Daten fr Anwendung
	
	// MH: holt sich aus dem buffer den srcport (quasi den "socket" an der gegenstelle) (16bit) heraus
	unsigned int TCP_Socket = (buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];

	for (unsigned char a=0; a<Max_TCP_Sockets; a++) {
		tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

		//MH: vergleicht nun fr jeden offenen socket, ob srcport (steht in ->Store) dem bekannten srcport entspricht
		//MH: WO WIRD IP ADRESSE VERGLICHEN????? TODO????
		if (TCP_Socket == tcp_socket->Store) {
			if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 
				&& (tcp_socket->Status == TCP_SOCKET_OPEN1 || tcp_socket->Status == TCP_SOCKET_OPEN2))
			{
				// MH: socket ist offen, also schn weitermachen
				*Stackpointer = a;
				return(0); //Daten fr Anwendung
			} else if (tcp_socket->Status == TCP_SOCKET_CLOSE) { // socket soll geschlossen werden, weil ende der daten (z.b. ende bei http)
				tcp_socket->Store = 0;
				tcp_socket->Status = TCP_SOCKET_NOT_USED;

//				printf("CL->FI(%u)(%u)->FIN,ACK\n", TCP_Socket, a);
				printf("CL->del(%u)(%u)->CLS(FIN,ACK)\n", TCP_Socket, a);
				TCP_PORT_CLOSE(buffer, bufferlen); // speichert seq/ack, sendet FIN|ACK antwort
//				tcp_socket->Status = TCP_SOCKET_FINISHING; //TCP Socket wird im TCP STACK geschlossen
				*Stackpointer = a;
				// wir haben das letzte wort. und erwarten nun keine daten mehr vom socket
				return(1); //Keine Daten fr Anwendung
			} else if (tcp_socket->Status == TCP_SOCKET_NOT_USED) {
				printf("NU->O1(%u)(%u)\n", TCP_Socket, a);
//				printf("TcpOpen(%u),Lvl(%u)\n", TCP_Socket, a);
				tcp_socket->Status = TCP_SOCKET_OPEN1; //TCP Socket wird im TCP Stack geffnet
				*Stackpointer = a;
				return(0); //keine daten fr anwendung, ABER es hat sich was
				// am zustand der verbindung gendert. anwendung kann dies nun bei
				// bedarf behandeln (mu halt ->Status dafr auswerten)
			} else if ((buffer[TCP_HDRFLAGS+1]&ACK_FLAG) > 0 
				&& (tcp_socket->Status == TCP_SOCKET_OPEN1 || tcp_socket->Status == TCP_SOCKET_OPEN2))
			{
				*Stackpointer = a;
				return(0); // socket ist offen,
			}
		}
	}
	return (1);
}
